{% extends "base-backend.html" %}
{% block content %}

<!-- admin-panel_page -->

<div class="ds-narrow-container">

  <div class="grid ds-header-title">
    <div class="g-col-12">
      <h1>
        {# i18n: Main title displayed on site configuration page (/admin) #}
        {{ _("Site configuration") }}
      </h1>
    </div>
  </div>

  <div class="grid mt-3">
    <div class="g-col-12">
      <p class="mb-0">{{ _("Manage this site's configuration.") }}</p>
    </div>
  </div>

  <div class="grid mt-3">
    <div class="g-col-12">
      <div class="card">
        <div class="card-header">
          <h2>
          {# i18n: Subtitle displayed on instance configuration page (/admin) #}
          {{ _("Site settings") }}
          </h2>
        </div>
        <div class="card-body">
          <ul class="ds-list-group">
            <li>
              <span>{{ _("Look and feel") }}</span>
              <span><a href="{{url_for('site_bp.look_and_feel')}}" class="ds-link-contain-icon">{{ _("Configure") }}<i data-feather="chevron-right" aria-hidden="true"></i></a></span>
            </li>
            <li>
              {# i18n: Settings about email server used by website to send email messages #}
              <span>{{ _("Email server") }}: <strong>{{g.site.smtp_config["host"]}}</strong></span>
              {# i18n: Button to configure some option #}
              <span><a href="{{url_for('site_bp.smtp_config')}}" class="ds-link-contain-icon">{{ _("Configure") }}<i data-feather="chevron-right" aria-hidden="true"></i></a></span>
            </li>
            <li>
              {% if custom_languages|length == 1 %}
                <span>{{ _("Custom translations") }}</span>
              {% else %}
              {% set languages = [] %}
              {% for language in custom_languages %}
                {% set languages = languages.append(language.name) %}
              {% endfor -%}
              <span>{{ _("Custom translations") }}: <strong>{{ ', '.join(languages) }}</strong></span>
              {% endif %}
              <span class="text-nowrap">
                <a href="{{url_for('site_bp.custom_languages')}}" class="ds-link-contain-icon">{{ _("Configure") }}<i data-feather="chevron-right" aria-hidden="true"></i></a>
              </span>
            </li>
            {% if config['ENABLE_LDAP'] %}
            <li>
              <span>LDAP: <strong>{{ config['LDAP_SERVER'] }}</strong></span>
              <span><a href="{{ url_for('site_bp.ldap_config') }}" class="ds-link-contain-icon">{{ _("Configure") }}<i data-feather="chevron-right" aria-hidden="true"></i></a></span>
            </li>
            {% endif %}
          </ul>
        </div>
      </div>
    </div>
  </div>

  <div class="grid mt-4">
    <div class="g-col-12">
      <div id="custom-texts" class="card">
        <div class="card-header">
          <h2 class="d-inline">
            {# i18n: Subtitle displayed on instance configuration page (/admin) #}
            {{ _("Custom texts") }}
          </h2>
        </div>
        <div class="card-body">
          <ul class="ds-list-group">
            <li>
              <span>
                {# i18n: Option in admin settings about changing instance welcoming text #}
                {{ _("Front page text") }}
              </span>
              <span><a href="{{url_for('site_bp.edit_blurb')}}" class="ds-link-contain-icon">{{ _("Edit") }}<i data-feather="chevron-right" aria-hidden="true"></i></a></span>
            </li>
            <li>
              <span>
                {# i18n: Option in admin settings about changing the message displayed when a new form is created #}
                {{ _("New form message") }}:
                <strong>
                {% if g.site.new_form_msg['enabled'] %}
                {{ _("Enabled") }}
                {% else %}
                {{ _("Disabled") }}
                {% endif %}
                </strong>
              </span>
              <span><a href="{{url_for('site_bp.new_form_msg')}}" class="ds-link-contain-icon">{{ _("Edit") }}<i data-feather="chevron-right" aria-hidden="true"></i></a></span>
            </li>
            <li>
              {# i18n: Option in admin setting to edit the User invitation text #}
              <span>{{ _("User invitation template") }}</span>
              <span><a href="{{url_for('site_bp.invitation_template')}}" class="ds-link-contain-icon">{{ _("Edit") }}<i data-feather="chevron-right" aria-hidden="true"></i></a></span>
            </li>
            <li>
              {# i18n: Option in admin setting to edit the Resources menu #}
              <span>{{ _("Resources menu") }}</span>
              <span><a href="{{url_for('site_bp.edit_resources_menu')}}" class="ds-link-contain-icon">{{ _("Edit") }}<i data-feather="chevron-right" aria-hidden="true"></i></a></span>
            </li>
            <li>
              <span>{{ _("Other information") }}</span>
              <span><a href="{{url_for('site_bp.edit_contact_info')}}" class="ds-link-contain-icon">{# i18n: Button to change some option #}{{ _("Edit") }}<i data-feather="chevron-right" aria-hidden="true"></i></a></span>
            </li>
          </ul>
        </div>
      </div>
    </div>
  </div>

  <div class="grid mt-4">
    <div class="g-col-12">
      <div id="data-protection" class="card">
        <div class="card-header">
          <h2>
            {# i18n: Subtitle displayed on instance configuration page (/admin) #}
            {{ _("Data protection") }}
          </h2>
        </div>
        <div class="card-body">
          <ul class="ds-list-group">
            <li>
              <span>{{ _("Wizard settings") }}</span>
              <span><a href="{{url_for('site_bp.wizard_settings')}}" class="ds-link-contain-icon">{{ _("Configure") }}<i data-feather="chevron-right" aria-hidden="true"></i></a></span>
            </li>
            <li>
              <span>{{ _("Privacy statement library") }}</span>
              <span><a href="{{url_for('consent_bp.list_site_data_consents')}}" class="ds-link-contain-icon">{{ _("Manage") }}<i data-feather="chevron-right" aria-hidden="true"></i></a></span>
            </li>
            <li>
              <span>{{ _("All forms must include a data consent text") }}</span>
              <span>
                <div id="toggle_wizard_require" class="btn-group btn-toggle">
                  <button id="require_DPL_true" class="btn btn-sm {% if g.site.data_protection['require'] %} btn-primary {% else %} btn-outline-secondary {% endif %} ">{{ _("True") }}</button>
                  <button id="require_DPL_false" class="btn btn-sm {% if not g.site.data_protection['require'] %} btn-primary {% else %} btn-outline-secondary {% endif %} ">{{ _("False") }}</button>
                </div>
              </span>
            </li>
          </ul>
        </div>
      </div>
    </div>
  </div>

  <div class="grid mt-4">
    <div class="g-col-12">
      <div id="new-users" class="card">
        <div class="card-header">
          <h2>
            {# i18n: Subtitle displayed on instance configuration page (/admin) #}
            {{ _("New users") }}
          </h2>
        </div>
        <div class="card-body">
          <ul class="ds-list-group">
            <li>
              {# i18n: Whether to enable open registration or remain invitation only #}
              <span>{{ _("Invitation only") }}</span>
              <div id="toggle_invitation_only" class="btn-group btn-toggle">
                <button id="invitation_only_true" class="btn btn-sm {% if g.site.invitation_only %} btn-primary {% else %} btn-outline-secondary {% endif %}">{{ _("True") }}</button>
                <button id="invitation_only_false" class="btn btn-sm {% if not g.site.invitation_only %} btn-primary {% else %} btn-outline-secondary {% endif %}">{{ _("False") }}</button>
              </div>
            </li>
            <li>
              <span>{{ _("User registration form") }}</span>
              <span>
                <a href="{{url_for('site_bp.new_user_form_preview')}}" class="ds-link-contain-icon">{{_("Configure")}}<i data-feather="chevron-right" aria-hidden="true"></i></a>
              </span>
            </li>

            <li>
              <span>{{ _("Language") }}: <strong>{{ config['LANGUAGES'][g.site.newuser_language][0] }}</strong></span>
              <span>
                <a href="{{url_for('site_bp.set_new_user_language')}}" class="ds-link-contain-icon">{{_("Change")}}<i data-feather="chevron-right" aria-hidden="true"></i></a>
              </span>
            </li>
            {% if g.site.is_uploads_enabled() %}
            <li>
              {# i18n: Whether to enable new users attaching documents into forms #}
              <span>{{ _("Enable file uploads") }}</span>
              <div id="toggle_uploads_enabled" class="btn-group btn-toggle">
                <button id="uploads_enabled_true" class="btn btn-sm {% if g.site.newuser_enableuploads %} btn-primary {% else %} btn-outline-secondary {% endif %}">{{ _("True") }}</button>
                <button id="uploads_enabled_false" class="btn btn-sm {% if not g.site.newuser_enableuploads %} btn-primary {% else %} btn-outline-secondary {% endif %}">{{ _("False") }}</button>
              </div>
            </li>
            <li>
              <span>{{ _("Default upload limit") }}</span>
              <span>{{ StorageDomain.default_user_uploads_limit(human_readable=True) }}</span>
            </li>
            {% endif %}
            <li>
              <span>{{ _("Default timezone") }}</span>
              <span>{{config['DEFAULT_TIMEZONE']}}</span>
            </li>
          </ul>
        </div>
      </div>
    </div>
  </div>

  {% if config['ENABLE_UPLOADS'] %}
  <div class="grid mt-4">
    <div class="g-col-12">
      <div id="file-uploads" class="card">
        <div class="card-header">
          <h2>{{ _("File uploads") }}</h2>
        </div>
        <div class="card-body">
          {% set total_media_bytes = StorageDomain.total_media_usage() %}
          {% set total_attachments_bytes = StorageDomain.total_attachments_usage() %}
          {% set total_uploads = total_media_bytes + total_attachments_bytes %}
          {% set disk_limit = StorageDomain.total_disk_limit() %}
          <ul class="ds-list-group">
            <li>
              <span>{{ _("Total media") }}</span>
              <span>{{ StorageDomain.human_readable_bytes(total_media_bytes) }}</span>
            </li>
            <li>
              <span>{{ _("Total attachments") }}</span>
              <span>{{ StorageDomain.human_readable_bytes(total_attachments_bytes) }}</span>
            </li>
            <li>
              <span>
                {{ _("Total disk usage") }}
                <span class="badge rounded-pill {% if total_uploads < disk_limit %} text-bg-secondary {% else %} text-bg-danger {% endif %}">
                  {% if total_uploads > 0 %}
                  {{'%0.2f' % (( total_uploads * 100) / disk_limit )|float}} %
                  {% else %}
                  0 %
                  {% endif %}
                </span>
              </span>
              <span>
                {{ _("%(total_uploads)s of %(disk_limit)s",
                      total_uploads = StorageDomain.human_readable_bytes(total_uploads),
                      disk_limit = StorageDomain.human_readable_bytes(disk_limit)
                      ) }}
              </span>
            </li>
            <li>
              {# i18n: Which type of attachments are allowed #}
              <span>{{ _("Form attachments") }}: <strong>{{ ', '.join(g.site.mimetypes.extensions) }}</strong></span>
              <span class="text-nowrap">
                <a href="{{url_for('site_bp.edit_mimetypes')}}" class="ds-link-contain-icon">{{ _("Configure") }}<i data-feather="chevron-right" aria-hidden="true"></i></a>
              </span>
            </li>
          </ul>
        </div>
      </div>
    </div>
  </div>
  {% endif %}

  <div class="grid mt-4">
    <div class="g-col-12">
      <div class="card">
        <div class="card-header">
          <h2>
            {# i18n: Title in Admin panel displaying info about installation #}
            {{ _("Installation") }}
          </h2>
        </div>
        <div class="card-body">
          <ul class="ds-list-group">
            <li>
              <span>{{ _("Created") }}</span>
              <span>{{g.site.created.astimezone(g.timezone).strftime("%Y-%m-%d")}}</span>
            </li>
            <li>
              <span>{{ _("Database schema") }}</span>
              <span>{{g.site.alembic_version()}}</span>
            </li>
            <li>
              <span>{{ _("Version") }}</span>
              <span>{{g.site.app_version()}}</span>
            </li>
          </ul>
        </div>
      </div>
    </div>
  </div>

</div>

<script>
const inline_help_file_name = "admin.j2.md";
document.getElementById('toggle_invitation_only')
        .addEventListener('click', function(evt){
    $.ajax({
        url : "{{url_for('site_bp.toggle_invitation_only')}}",
        type: "POST",
        dataType: "json",
        beforeSend: function(xhr, settings) {
            if (!/^(GET|HEAD|OPTIONS|TRACE)$/i.test(settings.type)) {
                xhr.setRequestHeader("X-CSRFToken", csrftoken)
            }
        },
        success: function(data, textStatus, jqXHR)
        {
            if (data.invite == true) {
                $('#invitation_only_true').addClass('btn-primary')
                                          .removeClass('btn-outline-secondary');
                $('#invitation_only_false').removeClass('btn-primary')
                                           .addClass('btn-outline-secondary');
            }
            else if (data.invite == false) {
                $('#invitation_only_true').removeClass('btn-primary')
                                          .addClass('btn-outline-secondary');
                $('#invitation_only_false').addClass('btn-primary')
                                           .removeClass('btn-outline-secondary');
            }
        }
    });
});
{% if g.site.is_uploads_enabled() %}
document.getElementById('toggle_uploads_enabled')
        .addEventListener('click', function(evt){
    $.ajax({
        url : "{{url_for('site_bp.toggle_newuser_uploads_default')}}",
        type: "POST",
        dataType: "json",
        beforeSend: function(xhr, settings) {
            if (!/^(GET|HEAD|OPTIONS|TRACE)$/i.test(settings.type)) {
                xhr.setRequestHeader("X-CSRFToken", csrftoken)
            }
        },
        success: function(data, textStatus, jqXHR)
        {
            if (data.uploads == true) {
                $('#uploads_enabled_true').addClass('btn-primary')
                                          .removeClass('btn-outline-secondary');
                $('#uploads_enabled_false').removeClass('btn-primary')
                                           .addClass('btn-outline-secondary');
            }
            else if (data.uploads == false) {
                $('#uploads_enabled_true').removeClass('btn-primary')
                                          .addClass('btn-outline-secondary');
                $('#uploads_enabled_false').addClass('btn-primary')
                                           .removeClass('btn-outline-secondary');
            }
        }
    });
});
{% endif %}
document.getElementById('toggle_wizard_require')
        .addEventListener('click', function(evt){
    $.ajax({
        url : "{{url_for('site_bp.toggle_wizard_require')}}",
        type: "POST",
        dataType: "json",
        beforeSend: function(xhr, settings) {
            if (!/^(GET|HEAD|OPTIONS|TRACE)$/i.test(settings.type)) {
                xhr.setRequestHeader("X-CSRFToken", csrftoken)
            }
        },
        success: function(data, textStatus, jqXHR)
        {
            if (data.require == true) {
                $('#require_DPL_true').addClass('btn-primary')
                                          .removeClass('btn-outline-secondary');
                $('#require_DPL_false').removeClass('btn-primary')
                                           .addClass('btn-outline-secondary');
            }
            else if (data.require == false) {
                $('#require_DPL_true').removeClass('btn-primary')
                                                   .addClass('btn-outline-secondary');
                $('#require_DPL_false').addClass('btn-primary')
                                                    .removeClass('btn-outline-secondary');
            }
        }
    });
});
{% if goto %}
$('html, body').animate({scrollTop: $('#{{goto}}').offset().top + (-81)}, "fast");
{% endif %}
</script>

{% endblock %}
